/*###############################################################################
## ETiles project
##
## Copyright (C) 2010 Carlos Villegas Núñez  carlos.villegasnunez@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#ifndef CARGARTILESET_H
#define CARGARTILESET_H

#include <QDialog>
#include "tile.h"
#include "mapa.h"

namespace Ui {
    class cargartileset;
}

class cargartileset : public QDialog {
    Q_OBJECT
public:
    /** Contructor de la clase cargartileset. Inicializa los datos necesarios del diálogo.
     * @param parent: Referencia a la instancia que se encarga de llamar al constructor.
     * @param tiles: Referencia a la lista de tiles donde se introduciran los tiles que componen el tileset.
     * @param anchura: Patrón de la anchura para dividir la imagen.
     * @param altura: Patrón de la altura para dividir la imagen.
     */
    cargartileset(QWidget *parent = 0,Tile *tiles = 0, int anchura=20, int altura=20);
    /** Destructor de la clase cargartileset.*/
    ~cargartileset();

protected:
    /** Procedimiento que se encarga de cambiar de evento
     * @param e: Parámetro que identifica el evento producido
    */
    void changeEvent(QEvent *e);
private:
    Ui::cargartileset *ui;
    Tile *t;
    int anchuraT,alturaT;
    QString fileName;
private slots:
    /** Procedimiento ligado a la acción sobre el botón cancelar que devuelve el estado cancelado sobre el diálogo*/
    void on_BCancelar_clicked();
    /** Procedimiento ligado a la acción sobre el botón examinar que abre un diálogo que nos permite seleccionar el nombre de fichero a cargar*/
    void on_BExaminar_clicked();
    /** Procedimiento ligado a la acción sobre el botón aceptar que divide la imagen del tileset según el patrón de tile e introduce cada uno de ellos en la lista de tiles*/
    void on_BAceptar_clicked();
};

#endif // CARGARTILESET_H
