/*###############################################################################
## ETiles project
##
## Copyright (C) 2010 Carlos Villegas Núñez  carlos.villegasnunez@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#ifndef MALEATORIOS_H
#define MALEATORIOS_H

#include <QDialog>
#include <listatiles.h>
#include <cargartileset.h>
#include <tile.h>

namespace Ui {
    class maleatorios;
}

class maleatorios : public QDialog {
    Q_OBJECT
public:
    /** Constructor de la clase maleatorios, que se encargar de inicializar los componentes que formaran el diálogo de creación de mapas aleatorios
    * @param parent: Puntero a la instancia que se encargar de realizar la creación
    */
    maleatorios(QWidget *parent = 0);
    /** Destructor de la clase maleatorio*/
    ~maleatorios();

protected:
    /** Procedimiento que se encarga de cambiar de evento
     * @param e: Parámetro que identifica el evento producido
     */
    void changeEvent(QEvent *e);

private:
    ListaTiles listatiles;
    Tile *tiles;
    Ui::maleatorios *ui;

private slots:
    void on_ssemilla_valueChanged(int value);
    /** Procedimiento ligado a la acción sobre el botón cancelar, indicando que se cancela la creación del mapa aleatorio*/
    void on_buttonBox_rejected();
    /** Procedimiento ligado a la acción sobre el botón aceptar, indicando que puede se puede proceder a la creación del mapa aleatorio*/
    void on_buttonBox_accepted();
    /** Procedimiento encargado de eliminar un tile de la lista de tiles interna del diálogo*/
    void EliminarTile();
    /** Procedimiento encargado de añadir un tile a la lista de tiles interna del diálogo*/
    void AnadirTile();
    /** Procedimiento encargado de cargar un tile de la lista de tiles interna del diálogo*/
    void AnadirTileSet();
};

#endif // MALEATORIOS_H
