/*###############################################################################
## ETiles project
##
## Copyright (C) 2010 Carlos Villegas Núñez  carlos.villegasnunez@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include "propmapa.h"
#include "ui_propmapa.h"

#include "QPainter"

propmapa::propmapa(QWidget *parent, QColor crejilla, QColor cmapa, QColor csel) :
    QDialog(parent), cr(crejilla), cf(cmapa), cs(csel),
    ui(new Ui::propmapa)
{
    ui->setupUi(this);

    ui->elegirf->setAutoFillBackground(true);
    ui->elegirr->setAutoFillBackground(true);
    ui->elegirs->setAutoFillBackground(true);

    //QPalette pm=ui->elegirf->palette();
    //pm.setColor(ui->elegirf->backgroundRole(),cmapa);
    //ui->elegirf->setPalette(pm);

    //QPalette pm(cmapa);
    int clr = cmapa.red(),clg=cmapa.green(),clb=cmapa.blue();
    QString cstylesheetf("background-color: rgb("); cstylesheetf += QString::number(clr); cstylesheetf += ','; cstylesheetf += QString::number(clg); cstylesheetf += ',';cstylesheetf += QString::number(clb); cstylesheetf += ");"; cstylesheetf += "color: rgb(255, 255, 255)";
    ui->elegirf->setStyleSheet(cstylesheetf);
    //ui->label_4->setText(cstylesheet);
    //ui->elegirf->setPalette(pm);

    clr = crejilla.red(),clg=crejilla.green(),clb=crejilla.blue();
    QString cstylesheetr("background-color: rgb("); cstylesheetr += QString::number(clr); cstylesheetr += ','; cstylesheetr += QString::number(clg); cstylesheetr += ',';cstylesheetr += QString::number(clb); cstylesheetr += ");"; cstylesheetr += "color: rgb(255, 255, 255)";
    ui->elegirr->setStyleSheet(cstylesheetr);

    clr = csel.red(),clg=csel.green(),clb=csel.blue();
    QString cstylesheets("background-color: rgb("); cstylesheets += QString::number(clr); cstylesheets += ','; cstylesheets += QString::number(clg); cstylesheets += ',';cstylesheets += QString::number(clb); cstylesheets += ");"; cstylesheets += "color: rgb(255, 255, 255)";
    ui->elegirs->setStyleSheet(cstylesheets);

    /*QPalette pr=ui->elegirr->palette();
    pr.setColor(ui->elegirr->backgroundRole(),crejilla);
    ui->elegirr->setPalette(pr);
    QPalette ps=ui->elegirs->palette();
    ps.setColor(ui->elegirs->backgroundRole(),csel);
    ui->elegirs->setPalette(ps);*/
}

propmapa::~propmapa()
{
    delete ui;
}

void propmapa::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void propmapa::on_elegirr_clicked()
{
    cr = diar.getColor(Qt::black, this);
    if (cr.isValid()) {
        /*QPalette p=ui->elegirr->palette();
        p.setColor(ui->elegirr->backgroundRole(),cr);
        ui->elegirr->setPalette(p);*/
        int clr = cr.red(),clg=cr.green(),clb=cr.blue();
        QString cstylesheet("background-color: rgb("); cstylesheet += QString::number(clr); cstylesheet += ','; cstylesheet += QString::number(clg); cstylesheet += ',';cstylesheet += QString::number(clb); cstylesheet += ");"; cstylesheet += "color: rgb(255, 255, 255)";
        ui->elegirr->setStyleSheet(cstylesheet);
    }

}

void propmapa::on_elegirs_clicked()
{
    cs = dias.getColor(Qt::black, this);
    cs.setAlpha(125);
    if (cs.isValid()) {
        /*QPalette p=ui->elegirs->palette();
        p.setColor(ui->elegirs->backgroundRole(),cs);
        ui->elegirs->setPalette(p);*/
        int clr = cs.red(),clg=cs.green(),clb=cs.blue();
        QString cstylesheet("background-color: rgb("); cstylesheet += QString::number(clr); cstylesheet += ','; cstylesheet += QString::number(clg); cstylesheet += ',';cstylesheet += QString::number(clb); cstylesheet += ");"; cstylesheet += "color: rgb(255, 255, 255)";
        ui->elegirs->setStyleSheet(cstylesheet);
    }
}

void propmapa::on_elegirf_clicked()
{
    cf = diaf.getColor(Qt::black, this);
    if (cf.isValid()) {
        /*QPalette p=ui->elegirf->palette();
        p.setColor(ui->elegirf->backgroundRole(),cf);
        ui->elegirf->setPalette(p);*/
        int clr = cf.red(),clg=cf.green(),clb=cf.blue();
        QString cstylesheet("background-color: rgb("); cstylesheet += QString::number(clr); cstylesheet += ','; cstylesheet += QString::number(clg); cstylesheet += ',';cstylesheet += QString::number(clb); cstylesheet += ");"; cstylesheet += "color: rgb(255, 255, 255)";
        ui->elegirf->setStyleSheet(cstylesheet);
    }
}

void propmapa::on_buttonBox_accepted()
{
   ((VentanaPrincipal*)(this->parentWidget()))->getMapa()->setColorFondo(cf);
   ((VentanaPrincipal*)(this->parentWidget()))->getMapa()->setColorRejilla(cr);
   ((VentanaPrincipal*)(this->parentWidget()))->getMapa()->setColorSel(cs);
   ((VentanaPrincipal*)(this->parentWidget()))->getMapa()->update();
   accept();
}

void propmapa::on_buttonBox_rejected()
{
    reject();
}
