/*###############################################################################
## ETiles project
##
## Copyright (C) 2010 Carlos Villegas Núñez  carlos.villegasnunez@alum.uca.es
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################*/

#include "redimensionar.h"
#include "ui_redimensionar.h"

redimensionar::redimensionar(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::redimensionar)
{
    ui->setupUi(this);

    //Tomamos los valores de anchura y altura del mapa para mostrar las dimensiones actuales del mapa
    QString cadanc,cadalt;
    cadanc += QString::number(((VentanaPrincipal*)(this->parentWidget()))->getMapa()->AnchuraTile());
    cadanc += 'x';
    cadanc += QString::number(((VentanaPrincipal*)(this->parentWidget()))->getMapa()->NumAnchuraTile());
    cadalt += QString::number(((VentanaPrincipal*)(this->parentWidget()))->getMapa()->AlturaTile());
    cadalt += 'x';
    cadalt += QString::number(((VentanaPrincipal*)(this->parentWidget()))->getMapa()->NumAlturaTile());

    ui->LAnchura->setText(cadanc);
    ui->LAltura->setText(cadalt);
}

redimensionar::~redimensionar()
{
    delete ui;
}

void redimensionar::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void redimensionar::on_BAceptar_clicked()
{
    //LLamamos a la funcion encargar de redimensionar
    ((VentanaPrincipal*)(this->parentWidget()))->RedimensionarMapa(ui->EAnchura->text().toInt(),ui->EAltura->text().toInt(),ui->ENumAnchura->text().toInt(),ui->ENumAltura->text().toInt());
    accept();
}

void redimensionar::on_BRechazar_clicked()
{
    reject();
}
